datablock AudioProfile(zBombExplosionSound)
{
   filename    = "./zBombExplode.wav";
   description = AudioDefault3d;
   preload = false;
};

datablock AudioProfile(zBombBounceSound)
{
   filename    = "./zBombBounce.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(zBombEquipSound)
{
   filename    = "./zBombEquip.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(zBombFuseSound)
{
   filename    = "./zBombFuse.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(zBombFuseParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/star1";
  colors[0] = "1 0.6 0.2 0.5";
  colors[1] = "1 0.5 0 0.5";
  colors[2] = "1 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 0.2;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(zBombFuseEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 3;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 15;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "zBombFuseParticle";
};

datablock ParticleData(zBombThrownParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 1;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/star1";
  colors[0] = "1 0.6 0.2 0.5";
  colors[1] = "1 0.5 0 0.5";
  colors[2] = "1 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 0.2;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(zBombThrownEmitter)
{
  uiName = "";
  ejectionPeriodMS = 2;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 3;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 15;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "zBombThrownParticle";
};
datablock ParticleData(zBombEventedTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 00;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.2 0.2 0.4";
	colors[1]     = "0.6 0.4 0.0 0.0";
	sizes[0]      = 0.50;
	sizes[1]      = 0.75;

	useInvAlpha = false;
};
datablock ParticleEmitterData(zBombEventedTrailEmitter)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "zBombEventedTrailParticle";
};

datablock ParticleData(zBombSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 3500;
  lifetimeVarianceMS = 1500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -1;
  spinRandomMax = 1;
  colors[0] = "0 0 0 1";
  colors[1] = "0 0 0 0";
  sizes[0] = 10;
  sizes[1] = 20;
  useInvAlpha = true;
  windCoefficient = 1;
};

datablock ParticleEmitterData(zBombSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 10;
  velocityVariance = 1;
  ejectionOffset = 4;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "zBombSmokeParticle";
};

datablock ExplosionData(zBombEventedExplosion)
{
   //explosionShape = "";

   lifeTimeMS = 150;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";

   damageRadius = 0;
   radiusDamage = 100;

   impulseRadius = 0;
   impulseForce = 4000;
};

datablock ExplosionData(zBombExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
   lifeTimeMS = 150;

   soundProfile = zBombExplosionSound;
   
   //emitter[1] = "";
   //emitter[2] = "";
   //emitter[0] = "";

   particleEmitter = zBombSmokeEmitter;
   particleDensity = 10;
//   particleDensity = 0;
   particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "0.4 0.4 0.4";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 13;
   impulseForce =  1300;

   //radius damage
   damageRadius = 8;
   radiusDamage = 20;

};

//projectile
AddDamageType("zBombDirect",   '<bitmap:add-ons/Weapon_zBomb/ci_zBomb> %1',    '%2 <bitmap:add-ons/Weapon_zBomb/ci_zBomb> %1',1,1);
AddDamageType("zBombRadius",   '<bitmap:add-ons/Weapon_zBomb/ci_zBomb> %1',    '%2 <bitmap:add-ons/Weapon_zBomb/ci_zBomb> %1',1,0);
datablock ProjectileData(zBombProjectile)
{
   projectileShapeName = "./zBombPR.dts";
   directDamage        = 0;
   directDamageType  = $DamageType::zBombDirect;
   radiusDamageType  = $DamageType::zBombRadius;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = zBombExplosion;
   particleEmitter     = zBombThrownEmitter;
  

  brickExplosionRadius = 0;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 20;
   brickExplosionMaxVolume = 200;
   brickExplosionMaxVolumeFloating = 200;

   muzzleVelocity      = 30;
   velInheritFactor    = 0;

   armingDelay         = 4500;
   lifetime            = 2500;
   fadeDelay           = 3000;
   bounceElasticity    = 0.4;
   bounceFriction      = 0.3;
   isBallistic         = true;
   gravityMod = 1;
      explodeOnDeath = true;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   sound = zBombFuseSound;
};

AddDamageType("zBombEventedDirect",   '<bitmap:add-ons/Weapon_zBomb/ci_zBomb> %1',    '%2 <bitmap:add-ons/Weapon_zBomb/ci_zBomb> %1',1,1);
datablock ProjectileData(zBombEventedProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 40;
   directDamageType    = $DamageType::zBombEventedDirect;
   radiusDamageType    = $DamageType::zBombEventedDirect;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 5;
   verticalImpulse     = 10;
   explosion           = zBombEventedExplosion;
   particleEmitter     = zBombEventedTrailEmitter;

   muzzleVelocity      = 150;
   velInheritFactor    = 1;

   armingDelay         = 5000;
   lifetime            = 450;
   fadeDelay           = 0;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.6;
   isBallistic         = false;
   gravityMod = 0;
   explodeOnDeath = false;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "0.9 0.3 0.1";
};


//////////
// item //
//////////
datablock ItemData(zBombItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./zBomb.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Zelda Bomb";
	iconName = "./icon_zBomb";
	doColorShift = false;
	colorShiftColor = "0.1 0.196 0.1 1.000";

	 // Dynamic properties defined by the scripts
	image = zBombImage;
	canDrop = true;
};

datablock ShapeBaseImageData(zBombImage)
{
   // Basic Item properties
   shapeFile = "./zBomb.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = zBombItem;
   ammo = " ";
   projectile = zBombProjectile;
   projectileType = Projectile;

   	casing = zBombPinDebris;
	shellExitDir        = "-2.0 1.0 1.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   //colorShiftColor = "0.10 0.196 0.1 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state

   	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]					= zBombEquipSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "FuseStart";
	stateAllowImageChange[1]	= true;

	stateName[2]			= "FuseStart";
	stateTransitionOnTimeout[2]	= "FuseStarted";
	stateAllowImageChange[2]	= false;
	stateTimeoutValue[2]		= 0.2;
	stateEjectShell[2]       = true;
	stateScript[2] = "onFuseStart";

	stateName[3]			= "FuseStarted";
	stateTransitionOnTriggerDown[3]	= "Charge";
	stateAllowImageChange[3]	= false;
	
	stateName[4]                    = "Charge";
	stateTransitionOnTimeout[4]	= "Armed";
	stateTimeoutValue[4]            = 0.7;
	stateWaitForTimeout[4]		= false;
	stateTransitionOnTriggerUp[4]	= "AbortCharge";
	stateScript[4]                  = "onCharge";
	stateAllowImageChange[4]        = false;
	
	stateName[5]			= "AbortCharge";
	stateTransitionOnTimeout[5]	= "FuseStarted";
	stateTimeoutValue[5]		= 0.3;
	stateWaitForTimeout[5]		= true;
	stateScript[5]			= "onAbortCharge";
	stateAllowImageChange[5]	= false;

  stateName[6] = "Armed";
  stateTransitionOnTriggerUp[6] = "Fire";
  stateAllowImageChange[6] = false;
  stateSound[6] = zBombFuseSound;
  stateEmitter[6] = zBombFuseEmitter;
  stateEmitterTime[6] = 1;
  stateEmitterNode[6] = "fuseNode";
  stateTransitionOnTimeout[6] = "Armed";
  stateTimeoutValue[6] = 1;
  stateWaitForTimeout[6] = false;

	stateName[7]			= "Fire";
	stateTransitionOnTimeout[7]	= "Done";
	stateTimeoutValue[7]		= 0.5;
	stateFire[7]			= true;
	stateSequence[7]		= "fire";
	stateScript[7]			= "onFire";
	stateWaitForTimeout[7]		= true;
	stateAllowImageChange[7]	= false;

	stateName[8]					= "Done";
	stateScript[8]					= "onDone";

};

package zBombPackage
{
	function Armor::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f)
	{
		if(%col.dataBlock $= "zBombItem" && %col.canPickup)
		{
			for(%i=0;%i<%this.maxTools;%i++)
			{
				%item = %obj.tool[%i];
				if(%item $= 0 || %item $= "")
				{
					%freeSlot = 1;
					break;
				}
			}

			if(%freeSlot)
			{
				%obj.pickup(%col);
				return;
			}
		}
		Parent::onCollision(%this, %obj, %col, %a, %b, %c, %d, %e, %f);
	}

	function projectile::onAdd(%obj,%a,%b)
	{
		parent::onAdd(%obj,%a,%b);
		if(%obj.dataBlock $= "zBombProjectile")
		{
			if(!%obj.isBurned)
			{
		         //%original = %obj.getDatablock().lifetime; Doesn't work for some reason
			 %oldLT = 4000;
		 	 //echo("Original is:" SPC %oldLT);
		 	 %cookTime = %obj.client.player.chargeTime;
		 	 //echo("Cooktime is:" SPC %cookTime);
		 	 %new = %oldLT - %cookTime;
		 	 //echo("Difference is:" SPC %new);
			 %obj.schedule(%new,"explode"); //Makes it so it explodes quicker if you held it longer
			}
		}
	}

};
activatePackage(zBombPackage);

function zBombImage::onFuseStart(%this, %obj, %slot)
{
   %obj.chargeStart = getSimTime();
   if(!isEventPending(%obj.burnSched))
      %obj.burnSched = schedule(4000,0,"burnedIt",%obj);
}

function zBombImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
	%obj.lastFragSlot = %obj.currTool;
}

function zBombImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function zBombProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	serverPlay3D(zBombBounceSound,%obj.getTransform());
}

function zBombImage::onFire(%this, %obj, %slot)
{
	cancel(%obj.burnSched);
	%obj.playthread(2, spearThrow);
	%obj.chargeEnd = getSimTime();
	%obj.chargeTime = %obj.chargeEnd - %obj.chargeStart;
	Parent::OnFire(%this, %obj, %slot);

	%currSlot = %obj.lastFragSlot;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
}

function zBombImage::onUnMount(%this,%obj,%slot) 
{
  cancel(%obj.burnSched);
  parent::onUnMount(%this,%obj,%slot); 
}

//If they cooked it too long, it explodes in their hands
function burnedIt(%player)
{
      %pos = %player.getPosition();
      %player.tool[%currSlot] = 0;
      %player.weaponCount--;
      %player.unMountImage(%slot);
      serverCmdUnUseTool(%player.client);
      %posx = getWord(%pos,0);
      %posy = getWord(%pos,1);
      %posz = getWord(%pos,2);

      %spawnpoint = %posx SPC %posy SPC %posz + 2;

      %burned = new Projectile()
      {
	 datablock = zBombProjectile;
	 initialVelocity = 0;
	 initialPosition = %spawnpoint;
	 sourceObject = %player;
	 sourceSlot = %player.lastFragSlot;
	 client = %player.client;
	 isBurned = true;
      };
      missionCleanup.add(%burned);
      %burned.explode();
}

function zBombImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}
   function zBombProjectile::onExplode(%this,%obj)
{
   parent::onExplode(%this, %obj);
   //echo("Grenade Explosion");
   %zBombEventedData = zBombEventedProjectile;
   %position = %obj.getPosition();

   %shards = getRandom(85,90);

   for(%numbar=0; %numbar<%shards; %numbar++)
   {
      %vector = %position;

      %x = (getRandom(-7,7) - 0.5) * 3.141592653;
      %y = (getRandom(-7,7) - 0.5) * 3.141592653;
      %z = (getRandom(-7,7) - 0.5) * 3.141592653;

      //spawn them in random sphere locations.

      if(%z < 0)
      {
	 %z = randNegate(%z); //Randomly Negates Negative Z (Up/Down) Velocities to make it spread more evenly
      }

      %velocity = %x SPC %y SPC %z;

      %zBombEventeds = new projectile()
      {
	 dataBlock = %zBombEventedData;
	 initialVelocity = %velocity;
	 initialPosition = %position;
	 sourceObject = %obj;
	 sourceSlot = %obj.client.player.lastFragslot;
	 client = %obj.client;
      };
      MissionCleanup.add(%zBombEventeds);
      //echo(%obj.client.getplayername());
      //echo(%obj.client.player.getID());
   }
}


function randNegate(%x)
{
   %rand = getRandom(1,100);
   if(%rand >= 50)
      return %x;

   if(%rand < 50)
   {
      %x = %x * (-1);
      return %x;
   }
}

function zBombEventedProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	if(%col.getClassName() $= "fxDTSBrick")
	{
		$InputTarget_["Self"] = %col;
		$InputTarget_["Player"] = %obj.client.player;
		$InputTarget_["Client"] = %obj.client;
		if($Server::LAN)
		{
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj.client);
		}
		else
		{
			if(getMiniGameFromObject(%col) == getMiniGameFromObject(%obj.client))
			{
				$InputTarget_["MiniGame"] = getMiniGameFromObject(%col);
			}
			else
			{
				$InputTarget_["MiniGame"] = 0;
			}
		}
		%col.processInputEvent(onZeldaBombed,%obj.client);
	}
}